<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

			<title>Wie können wir effizient mit bibliothekarischen Datenbanken über Programmierschnittstelle (APIs) kommunizieren?</title>

			<meta name="description" content="Python Intro for Libraries">
		<meta name="author" content="José Calvo Tello">

		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<link rel="stylesheet" href="../../lib/reveal/dist/reset.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/reveal.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/theme/white.css" id="theme">
		<link rel="stylesheet" href="custom.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="../../lib/reveal/plugin/highlight/monokai.css" id="highlight-theme">
	</head>

	<body>

        <div class="reveal">
            <div class="slides">

				<section data-markdown="" data-separator="^\n---\n" data-separator-vertical="^\n--\n" data-charset="utf-8">
					<script type="text/template">
<!-- .slide: class="firstSlide" -->
#### APIs in der Bibliothek
##### Wie können wir effizient mit bibliothekarischen Datenbanken kommunizieren?

<br/>

###### Besuch der niedersächsischen Referendar:innen, SUB Göttingen, 29.03.2022

<hr />

###### Dr. José Calvo Tello (INIG und FE, SUB Göttingen)

<hr />
<img data-src="./img/application programming interface in a library full of books_replicate-prediction-tj3ghplj5jd5xkjinlu4xin6py.png" width="300"/>
<br />
<img data-src="./../../images/GAU_SUB_horizontal_cmyk.jpg" width="400"/>

---

# Neue Anforderungen

--

# Neue Anforderungen

* Ich möchte alle Romane,
	* die ursprünglich auf Italienisch verfasst wurden,
	* die das erste Mal zwischen 1700 und 2000 veröffentlicht wurden,
	* deren Handlung in Europa stattfindet,
	* 50% sollen von Frauen geschrieben sein.
* Davon möchte ich, dass eine Ausgabe
	* online frei verfügbar
	* oder im Bestand der SUB Göttingen ist,
	* am besten als E-Book vorliegt
	* oder neu günstiger als 10€ ist.
* Ich möchte alle Ergebnisse in einer Zotero-Bibliographie.

--

# Dafür brauchen wir eigentlich nur zwei Sachen

1. Quellen mit Daten
2. Dass diese Quellen miteinander kommunizieren können


--

## Wie kommunizieren Datenbanken mitainender?
# Durch APIs!

---


# Was ist eine API?

--

## Was ist eine API?

* Application Programming Interface
* "A web API allows for information or functionality to be manipulated by other programs via the internet. For example, with Twitter’s web API, you can write a program in a language like Python or Javascript that can perform tasks such as favoriting tweets or collecting tweet metadata."
* Quelle: Patrick Smyth, "Creating Web APIs with Python and Flask," Programming Historian 7 (2018), https://doi.org/10.46430/phen0072

--

* "In programming more generally, the term API, short for Application Programming Interface, refers to a part of a computer program designed to be used or manipulated by another program, as opposed to an interface designed to be used or manipulated by a human."
* (Smyth 2018)


--

# When to Create an API

* "If you have data you wish to share with the world, an API is one way you can get it into the hands of others. However, APIs are not always the best way of sharing data with users. If the size of the data you are providing is relatively small, you can instead provide a “data dump” in the form of a downloadable JSON, XML, CSV, or SQLite file. "
* (Smyth 2018)


--


# When to Create an API

* In general, consider an API if:
	* Your data set is large, making download via FTP unwieldy or resource-intensive.
	* Your users will need to access your data in real time, such as for display on another website or as part of an application.
	* Your data changes or is updated frequently.
	* Your users only need access to a part of the data at any one time.
	* Your users will need to perform actions other than retrieve data, such as contributing, updating, or deleting data.
* (Smyth 2018)



---

# K10plus APIs

--

* Pad: https://s.gwdg.de/IL5d4p


--

# K10plus APIs

* Dokummentation: https://wiki.k10plus.de/display/K10PLUS/K10plus-Services
* UnAPI: https://wiki.k10plus.de/display/K10PLUS/UnAPI
* SRU: https://wiki.k10plus.de/display/K10PLUS/SRU

--

## UnAPI
* "UnAPI bietet eine einfache, webbasierte Methode, um einzelne Datensätze in verschiedenen Formaten abzurufen."
* http://unapi.k10plus.de/?id=k10plus:ppn:1040148980&format=picajson
* http://unapi.k10plus.de/?id=k10plus:ppn:1681476401&format=picajson


--

* Beispiele für unterschiedliche Output-Formate:
	* PICA+ JSON: http://unapi.k10plus.de/?id=k10plus:ppn:1040148980&format=picajson
	* PICA XML: http://unapi.k10plus.de/?id=k10plus:ppn:1040148980&format=picaxml
	* ISBD: http://unapi.k10plus.de/?id=k10plus:ppn:1040148980&format=isbd
	* Bibtex: http://unapi.k10plus.de/?id=k10plus:ppn:1040148980&format=bibtex

--

* Beispiele für unterschiedliche Datenbanken:
	* K10plus: http://unapi.k10plus.de/?id=k10plus:ppn:1040148980&format=picaxml
	* SUB Göttingen: http://unapi.k10plus.de/?id=opac-de-7:ppn:1040148980&format=picaxml
	* Regionalkatalog Hamburg: http://unapi.k10plus.de/?id=rk-hamburg:ppn:1040148980&format=picaxml


--

## SRU

* "Search/Retrieve via URL (SRU) ist ein technischer Standard für Bibliotheken, [ein] auf HTTP basierendes Protokoll um Datenbankabfragen durchzuführen. Suchanfragen können dabei über einen URL in CQL (Contextual Query Language) übermittelt werden. Die zurückgelieferten Ergebnisse können per XML in verschiedenen bibliographischen Formaten ausgeliefert werden."

--

# Beispiele

* Titel von Jane Austen geschrieben: http://sru.k10plus.de/k10plus!rec=1?version=1.1&query=pica.per=Austen,Jane&operation=searchRetrieve&maximumRecords=10&recordSchema=picaxml&startRecord=1

--


* Titel mit "Austen" im Titel: http://sru.k10plus.de/k10plus!rec=1?version=1.1&query=pica.tit=Austen&operation=searchRetrieve&maximumRecords=10&recordSchema=picaxml&startRecord=1
* Titel mit "Austen" im Titel, veröffentlicht in 2010: http://sru.k10plus.de/k10plus!rec=1?version=1.1&query=pica.tit=Austen%20and%20pica.jah=2010&operation=searchRetrieve&maximumRecords=10&recordSchema=picaxml&startRecord=1
* Titel mit "Austen" im Titel, die die Romanistik betreffen (BK 18.[23]): http://sru.k10plus.de/k10plus!rec=1?version=1.1&query=pica.tit=Austen%20and%20(pica.bkl=18.2?%20or%20pica.bkl=18.3?)&operation=searchRetrieve&maximumRecords=10&recordSchema=picaxml&startRecord=1

--

* Ist der Titel mit ISBN 978-1-000-44019-5 bereits im Bestand der SUB Göttinge?
	* http://sru.k10plus.de/opac-de-7!rec=1?version=1.1&query=pica.isb=978-1-000-44019-5&operation=searchRetrieve&maximumRecords=10&recordSchema=picaxml&startRecord=1
	* http://sru.k10plus.de/k10plus!rec=1?version=1.1&query=pica.isb=978-1-000-44019-5&operation=searchRetrieve&maximumRecords=10&recordSchema=picaxml&startRecord=1

---


# Anwendungsfälle

--

1. Deduplizierungstool
2. Erwerbungsworkflow über Zotero für Digital Humanities

--

## 1. Deduplizierungstool

* Situation: Tabelle mit einem Angebot von einem Verlag mit einem 20% Rabatt für E-Books
* Frage: Wieviele von diesen Titel sind bereits im Bestand?
	* Als E-Book oder als Print?

--

<img data-src="./img/6ai7ln.jpg" width="500"/>

--


## 1. Deduplizierungstool

* Normaler Weg
	* Jeden Titel händisch überprüfen
* Computergestützter Weg
	* Durch die Tabelle iterieren
	* ISBN als Identifier
	* Abfrage über die SRU API des K10plus
	* Überprüfen, ob Titel im Bestand der SUB sind
	* Daten in neuer Spalte hinzufügen

--

## 1. Deduplizierungstool

<img data-src="./img/Dedublizierungs-Tool.drawio.png" width="700"/>

--

## 2. Erwerbungsworkflow über Zotero für Digital Humanities

--

## Situation
* Das Institut für DH möchte Titel kaufen
* Diese Bücher können bereits im Bestand der Bibliothek sein
* Diese Bücher gehören zu mehreren Fächern (Germanistik, Geschichte, Kunstgeschichte, Informatik...)

--

## Ziel
* Die Vorschläge für Titel sollen dedupliziert werden
* Wenn die Titel noch nicht vorhanden sind,
	* dann muss jedes Buch zu einem Fach zugeordnet werden
	* damit die jeweiligen Fachreferent*innen entscheiden kann, ob der Titel erworben wird oder nicht

--

# Änderung des typischen Workflows

* <del>Erwerbung -> Erschließung </del>
* (grobe) Erschließung -> Erwerbung -> feine Erschließung

--

## 2. Erwerbungsworkflow über Zotero für Digital Humanities

<img data-src="./img/DH-workflow.drawio.png" width="700"/>

--

## Implementation

* Die Daten aus der Zotero-Bibliographie über die API extrahieren
* ISBN als Identifier
* Die Daten im Katalog über die API abfragen
* Titel deduplizieren

--


* Wenn der Titel im Bestand ist
	* **Tags "SUB:bereits_vorhanden" in Zotero hinzufügen**



--


* Wenn der Titel nicht im Bestand ist
	* Überprüfen, ob der Titel mit Sachgruppe, DDC oder BK Klasse bereits erschlossen ist
	* Wenn ja, diese Klassen in der **Zotero-Bibliographie über die API eintragen**
	* BK:21.42, DDC:720 Architektur
* Fachreferent*innen benutzen die Erschließung des Katalogs in der Zotero-Bibliographie für ihre Entscheidung zur Erwerbung

---

# Wie können Sie davon profitieren?


--

# Wie können Sie davon profitieren?

1. APIs, um mit Daten zu arbeiten
2. APIs, für strategische Entwicklung

--

## Mit Daten arbeiten
1. Programmieren (Python, R)
2. Datenformate (PICA, XML, JSON)
3. Data processing (Regular Expressions, xPATH, Pandas...)

--

## Niedrigschwellige Quelle

* Programming Historian: https://programminghistorian.org/
* Library Carpentries: https://librarycarpentry.org/
* Verlag O'Reilly

--

## APIs für strategische Entwicklung

1. Sind die Daten dieser Datenbank/Quelle eindeutig identifiziert?
	* PPN, EPN (ISBN)...
2. Sind Instanzen von anderen wichtigen Datenbanken eindeutig referenziert?
	* Z.B. zwischen Katalog und Erwerbungssystem
3. Bietet diese Datenbank eine API (oder Exportoptionen)?
	* Um Daten zu extrahieren,
	* zu bearbeiten
	* und neue hinzufügen?


---

## Abschluss

--

# Neue Anforderungen

* Ich möchte alle Romane,
	* die ursprünglich auf Italienisch verfasst wurden,
	* die das erste Mal zwischen 1700 und 2000 veröffentlicht wurden,
	* deren Handlung in Europa stattfindet,
	* 50% sollen von Frauen geschrieben sein.
* Davon möchte ich, dass eine Ausgabe
	* online frei verfügbar
	* oder im Bestand der SUB Göttingen ist,
	* am besten als E-Book vorliegt
	* oder neu günstiger als 10€ ist.
* Ich möchte alle Ergebnisse in einer Zotero-Bibliographie.

--

1. Quellen mit **gut erschlossenen** Daten
2. Dass diese Quellen miteinander kommunizieren können

--


* Die APIs sind nur eine neue Tür zu den guten alten Daten
* Erschließung von Daten:
	* Klassische Aufgabe? Egal!
	* Es ist weiterhin **zentral**!

--

## Danke für die Aufmerksamkeit!




					</script>
				</section>
            </div>
        </div>

        <script src="../../lib/reveal/dist/reveal.js"></script>
        <script src="../../lib/reveal/plugin/zoom/zoom.js"></script>
        <script src="../../lib/reveal/plugin/notes/notes.js"></script>
        <script src="../../lib/reveal/plugin/search/search.js"></script>
        <script src="../../lib/reveal/plugin/markdown/markdown.js"></script>
        <script src="../../lib/reveal/plugin/highlight/highlight.js"></script>
        <script>

          // Also available as an ES module, see:
          // https://revealjs.com/initialization/
          Reveal.initialize({
            controls: true,
            progress: true,
            center: true,
            hash: true,

            // Learn about plugins: https://revealjs.com/plugins/
            plugins: [ RevealZoom, RevealNotes, RevealSearch, RevealMarkdown, RevealHighlight ]
          });

        </script>

      </body>
    </html>
